/*#########################################################################
#                                                                         #
#   Simple script shamelessly recopied from:                              #
#                                                                         #
#   Copyright                                                             #
#                                                                         #
#   (C)  2010 Anselmo Lacerda Silveira de Melo <anselmolsm@gmail.com>     #
#   (C)  2010 Emile de Weerd <mederel+radionederland@gmail.com>           #
#   (C)  2009 MetalByte <emetalbyte@gmail.com>                            #
#   (C)  2009 Àlvar Cuevas i Fajardo <alvar@cuevas.cat>                   #
#   (C)  2008 Eirik Johansen Bjørgan  <eirikjbj@gmail.com>                #      
#   (C)  2008 Peter ZHOU <peterzhoulei@gmail.com>                         #
#   (C)  2008 Mark Kretschmann <kretschmann@kde.org>                      #
#   (C)  2007, 2008 Nikolaj Hald Nielsen  <nhnFreespirit@gmail.com>       #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
##########################################################################*/

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");

function Station( name, url, description )
{
    this.name = name;
    this.url = url;
    this.description = description;
}

categories = new Object;

categories["OldSchool Funk & Soul"]=new Array ( 
        new Station( "OldSchool Funk & Soul", "http://listen.sky.fm/public1/oldschoolfunknsoul.pls", "Classic Funky rhythms and Soulful grooves!") );
categories["Halloween Channel"]=new Array ( 
        new Station( "Halloween Channel", "http://listen.sky.fm/public1/halloween.pls", "The Spookiest Songs of the Season!") );
categories["Smooth Jazz"]=new Array ( 
        new Station( "Smooth Jazz", "http://listen.sky.fm/public1/smoothjazz.pls", "The worlds smoothest jazz 24 hours a day") );
categories["Love Music"]=new Array ( 
        new Station( "Love Music", "http://listen.sky.fm/public1/lovemusic.pls", "Easy listening and Romantic hits from the heart!!") );
categories["Top Hits"]=new Array ( 
        new Station( "Top Hits", "http://listen.sky.fm/public1/tophits.pls", "Who cares about the chart order, less rap & more hits!") );
categories["Classic Rock"]=new Array ( 
        new Station( "Classic Rock", "http://listen.sky.fm/public1/classicrock.pls", "Relive the classic rock sounds of the 70s and 80s") );
categories["Soft Rock"]=new Array ( 
        new Station( "Soft Rock", "http://listen.sky.fm/public1/softrock.pls", "The best in Soft Rock music!") );
categories["Smooth Lounge"]=new Array ( 
        new Station( "Smooth Lounge", "http://listen.sky.fm/public1/smoothlounge.pls", "Relax and unwind with the smoothest lounge vibes.") );
categories["New Age"]=new Array ( 
        new Station( "New Age", "http://listen.sky.fm/public1/newage.pls", "Soothing sounds of new age and world music!") );
categories["Solo Piano"]=new Array ( 
        new Station( "Solo Piano", "http://listen.sky.fm/public1/solopiano.pls", "Musical journeys with piano masters and talented undiscovered pianists") );
categories["Relaxation"]=new Array ( 
        new Station( "Relaxation", "http://listen.sky.fm/public1/relaxation.pls", "relaxing music for the mind and soul") );
categories["Mostly Classical"]=new Array ( 
        new Station( "Mostly Classical", "http://listen.sky.fm/public1/classical.pls", "Listen and Relax, it's good for you!") );
categories["Mellow Jazz"]=new Array ( 
        new Station( "Mellow Jazz", "http://listen.sky.fm/public1/mellowjazz.pls", "Relax and unwind to the Mellow side of Jazz.") );
categories["Café de Paris"]=new Array ( 
        new Station( "Café de Paris", "http://listen.sky.fm/public1/cafedeparis.pls", "Watch the world go by on a sunny Paris day.") );
categories["90's Hits"]=new Array ( 
        new Station( "90's Hits", "http://listen.sky.fm/public1/hit90s.pls", "Reminisce and relive the hits of the 90s!") );
categories["90's R&B"]=new Array ( 
        new Station( "90's R&B", "http://listen.sky.fm/public1/90srnb.pls", "The hottest 90s R&B hits and jams!") );
categories["Best of the 80's"]=new Array ( 
        new Station( "Best of the 80's", "http://listen.sky.fm/public1/the80s.pls", "Hear your classic favorites right here!") );
categories["80's Rock Hits"]=new Array ( 
        new Station( "80's Rock Hits", "http://listen.sky.fm/public1/80srock.pls", "Your favorite rock hits from the 80's!") );
categories["80's Dance"]=new Array ( 
        new Station( "80's Dance", "http://listen.sky.fm/public1/80sdance.pls", "The best 80s Dance Party on the web!") );
categories["Hit 70's"]=new Array ( 
        new Station( "Hit 70's", "http://listen.sky.fm/public1/hit70s.pls", "All Hits, All The Time!") );
categories["Best of the 60s"]=new Array ( 
        new Station( "Best of the 60s", "http://listen.sky.fm/public1/hit60s.pls", "Relive the memories of the 60’s greatest hits.") );
categories["60's Rock"]=new Array ( 
        new Station( "60's Rock", "http://listen.sky.fm/public1/60srock.pls", "The very best in classic 60s Rock!") );
categories["Pop Rock"]=new Array ( 
        new Station( "Pop Rock", "http://listen.sky.fm/public1/poprock.pls", "Pop rock hits on SKY.FM!!!") );
categories["Modern Rock"]=new Array ( 
        new Station( "Modern Rock", "http://listen.sky.fm/public1/modernrock.pls", "Where Modern rock lives on the net.") );
categories["Hard Rock"]=new Array ( 
        new Station( "Hard Rock", "http://listen.sky.fm/public1/hardrock.pls", "Bang along with the best Hard Rock tracks anywhere") );
categories["Metal"]=new Array ( 
        new Station( "Metal", "http://listen.sky.fm/public1/metal.pls", "Best Place for your METAL fix on the net") );
categories["Smooth Jazz 24'7"]=new Array ( 
        new Station( "Smooth Jazz 24'7", "http://listen.sky.fm/public1/smoothjazz247.pls", "The best of Smooth Jazz 24/7 on SKY.fm") );
categories["Modern Blues"]=new Array ( 
        new Station( "Modern Blues", "http://listen.sky.fm/public1/modernblues.pls", "Listen to the best in Modern Blues!") );
categories["Compact Discoveries"]=new Array ( 
        new Station( "Compact Discoveries", "http://listen.sky.fm/public1/compactdiscoveries.pls", "Theme-based shows of mostly classical music, jazz, folk, and other popular classics.") );
categories["Vocal New Age"]=new Array ( 
        new Station( "Vocal New Age", "http://listen.sky.fm/public1/vocalnewage.pls", "soothing vocal sounds of new age music!") );
categories["Nature"]=new Array ( 
        new Station( "Nature", "http://listen.sky.fm/public1/nature.pls", "soothing sounds of nature music!") );
categories["Movie Soundtracks"]=new Array ( 
        new Station( "Movie Soundtracks", "http://listen.sky.fm/public1/soundtracks.pls", "A wide variety of Soundtracks from Movies, show themes, & more!") );
categories["Relaxing Excursions"]=new Array ( 
        new Station( "Relaxing Excursions", "http://listen.sky.fm/public1/relaxingexcursions.pls", "Sit back and enjoy the relaxing sounds") );
categories["Ska"]=new Array ( 
        new Station( "Ska", "http://listen.sky.fm/public1/ska.pls", "Ska hits from the past to the present!") );
categories["Classic Motown"]=new Array ( 
        new Station( "Classic Motown", "http://listen.sky.fm/public1/classicmotown.pls", "Relive the hits and discover the early sounds of Motown.") );
categories["Oldies"]=new Array ( 
        new Station( "Oldies", "http://listen.sky.fm/public1/oldies.pls", "Three decades of great oldies on www.sky.fm") );
categories["Dreamscapes"]=new Array ( 
        new Station( "Dreamscapes", "http://listen.sky.fm/public1/dreamscapes.pls", "relax to the sounds of dream and ibiza style chillout") );
categories["Classical Piano Trios"]=new Array ( 
        new Station( "Classical Piano Trios", "http://listen.sky.fm/public1/classicalpianotrios.pls", "Classical Piano Trios hits!") );
categories["Classical Guitar"]=new Array ( 
        new Station( "Classical Guitar", "http://listen.sky.fm/public1/guitar.pls", "A mix of classical, spanish, and flamenco guitar") );
categories["Country"]=new Array ( 
        new Station( "Country", "http://listen.sky.fm/public1/country.pls", "Today's Hit Country with a mix of your favorites") );
categories["Roots Reggae"]=new Array ( 
        new Station( "Roots Reggae", "http://listen.sky.fm/public1/rootsreggae.pls", "The best of classic and modern Roots Reggae ") );
categories["Bossa Nova"]=new Array ( 
        new Station( "Bossa Nova", "http://listen.sky.fm/public1/bossanova.pls", "100% pure bossa nova channel, enjoy the sweet flavors of Brazil!") );
categories["Vocal Smooth Jazz"]=new Array ( 
        new Station( "Vocal Smooth Jazz", "http://listen.sky.fm/public1/vocalsmoothjazz.pls", "The best of vocal smooth jazz!!") );
categories["Uptempo Smooth Jazz"]=new Array ( 
        new Station( "Uptempo Smooth Jazz", "http://listen.sky.fm/public1/uptemposmoothjazz.pls", "The world's smoothest jazz, grooving 24 hours a day") );
categories["DaTempo Lounge"]=new Array ( 
        new Station( "DaTempo Lounge", "http://listen.sky.fm/public1/datempolounge.pls", "Amazing combination of jazz, lounge, bossa, and much more!") );
categories["Piano Jazz"]=new Array ( 
        new Station( "Piano Jazz", "http://listen.sky.fm/public1/pianojazz.pls", "Enjoy the sounds of piano jazz from historic and modern masters.") );
categories["Salsa"]=new Array ( 
        new Station( "Salsa", "http://listen.sky.fm/public1/salsa.pls", "Best Salsa Collection now on www.sky.fm") );
categories["World"]=new Array ( 
        new Station( "World", "http://listen.sky.fm/public1/world.pls", "New Age influenced world music") );
categories["Romantica"]=new Array ( 
        new Station( "Romantica", "http://listen.sky.fm/public1/romantica.pls", "Timeless pop classical voices!") );
categories["Alternative Rock"]=new Array ( 
        new Station( "Alternative Rock", "http://listen.sky.fm/public1/altrock.pls", "Alternative rock hits You want to hear!!") );
categories["Russian Pop"]=new Array ( 
        new Station( "Russian Pop", "http://listen.sky.fm/public1/russianpop.pls", "Top pop hits direct from Russia.") );
categories["Russian Dance Hits"]=new Array ( 
        new Station( "Russian Dance Hits", "http://listen.sky.fm/public1/russiandance.pls", "Russia's hottest dance tunes.") );
categories["Indie Rock"]=new Array ( 
        new Station( "Indie Rock", "http://listen.sky.fm/public1/indierock.pls", "Indie, Alternative, and Underground Rock!") );
categories["Dance Hits"]=new Array ( 
        new Station( "Dance Hits", "http://listen.sky.fm/public1/dancehits.pls", "The hottest dance tunes 24/7") );
categories["Urban Jamz"]=new Array ( 
        new Station( "Urban Jamz", "http://listen.sky.fm/public1/urbanjamz.pls", "Kickin' with the baddest beats on the 'net") );
categories["Pop Punk"]=new Array ( 
        new Station( "Pop Punk", "http://listen.sky.fm/public1/poppunk.pls", "A fusion of Punk and Pop!") );
categories["Classic Rap"]=new Array ( 
        new Station( "Classic Rap", "http://listen.sky.fm/public1/classicrap.pls", "The best in classic rap and hip hop!!") );
categories["Israeli Hits"]=new Array ( 
        new Station( "Israeli Hits", "http://listen.sky.fm/public1/israelihits.pls", "The best of current and classic Israeli hits.") );
categories["Bebop Jazz"]=new Array ( 
        new Station( "Bebop Jazz", "http://listen.sky.fm/public1/bebop.pls", "Swinging to the sounds of bebop and straight ahead jazz") );
categories["Jazz Classics"]=new Array ( 
        new Station( "Jazz Classics", "http://listen.sky.fm/public1/jazzclassics.pls", "Classic Jazz hits from the golden age") );
categories["American Songbook"]=new Array ( 
        new Station( "American Songbook", "http://listen.sky.fm/public1/americansongbook.pls", "Classic standard voices from the likes of Mel Torme & Nat King Cole") );
categories["A Beatles Tribute"]=new Array ( 
        new Station( "A Beatles Tribute", "http://listen.sky.fm/public1/beatles.pls", "Beatles Hits, Remakes, Tributes!!!") );
categories["Jpop"]=new Array ( 
        new Station( "Jpop", "http://listen.sky.fm/public1/jpop.pls", "A fine assortment of fresh Jpop hits!!") );
categories["Club Bollywood"]=new Array ( 
        new Station( "Club Bollywood", "http://listen.sky.fm/public1/clubbollywood.pls", "Dance Hits from Bollywood!!") );
categories["Contemporary Christian"]=new Array ( 
        new Station( "Contemporary Christian", "http://listen.sky.fm/public1/christian.pls", "Today's Christian favorites and undiscovered hits") );


images = new Object;
images["OldSchool Funk & Soul"]="oldschoolfunknsoul.png";
images["Halloween Channel"]="halloween.png";
images["Smooth Jazz"]="smoothjazz.png";
images["Love Music"]="lovemusic.png";
images["Top Hits"]="tophits.png";
images["Classic Rock"]="classicrock.png";
images["Soft Rock"]="softrock.png";
images["Smooth Lounge"]="smoothlounge.png";
images["New Age"]="newage.png";
images["Solo Piano"]="solopiano.png";
images["Relaxation"]="relaxation.png";
images["Mostly Classical"]="classical.png";
images["Mellow Jazz"]="mellowjazz.png";
images["Café de Paris"]="cafedeparis.png";
images["90's Hits"]="hit90s.png";
images["90's R&B"]="90srnb.png";
images["Best of the 80's"]="the80s.png";
images["80's Rock Hits"]="80srock.png";
images["80's Dance"]="80sdance.png";
images["Hit 70's"]="hit70s.png";
images["Best of the 60s"]="hit60s.png";
images["60's Rock"]="60srock.png";
images["Pop Rock"]="poprock.png";
images["Modern Rock"]="modernrock.png";
images["Hard Rock"]="hardrock.png";
images["Metal"]="metal.png";
images["Smooth Jazz 24'7"]="smoothjazz247.png";
images["Modern Blues"]="modernblues.png";
images["Compact Discoveries"]="compactdiscoveries.png";
images["Vocal New Age"]="vocalnewage.png";
images["Nature"]="nature.png";
images["Movie Soundtracks"]="soundtracks.png";
images["Relaxing Excursions"]="relaxingexcursions.png";
images["Ska"]="ska.png";
images["Classic Motown"]="classicmotown.png";
images["Oldies"]="oldies.png";
images["Dreamscapes"]="dreamscapes.png";
images["Classical Piano Trios"]="classicalpianotrios.png";
images["Classical Guitar"]="guitar.png";
images["Country"]="country.png";
images["Roots Reggae"]="rootsreggae.png";
images["Bossa Nova"]="bossanova.png";
images["Vocal Smooth Jazz"]="vocalsmoothjazz.png";
images["Uptempo Smooth Jazz"]="uptemposmoothjazz.png";
images["DaTempo Lounge"]="datempolounge.png";
images["Piano Jazz"]="pianojazz.png";
images["Salsa"]="salsa.png";
images["World"]="world.png";
images["Romantica"]="romantica.png";
images["Alternative Rock"]="altrock.png";
images["Russian Pop"]="russianpop.png";
images["Russian Dance Hits"]="russiandance.png";
images["Indie Rock"]="indierock.png";
images["Dance Hits"]="dancehits.png";
images["Urban Jamz"]="urbanjamz.png";
images["Pop Punk"]="poppunk.png";
images["Classic Rap"]="classicrap.png";
images["Israeli Hits"]="israelihits.png";
images["Bebop Jazz"]="bebop.png";
images["Jazz Classics"]="jazzclassics.png";
images["American Songbook"]="americansongbook.png";
images["A Beatles Tribute"]="beatles.png";
images["Jpop"]="jpop.png";
images["Club Bollywood"]="clubbollywood.png";
images["Contemporary Christian"]="christian.png";

function SkyFMRadios()
{
    // last argument is the filter box
    ScriptableServiceScript.call( this, "SKY.FM Radios", 2, "Enjoy amazing Free Internet Radio stations", "Quality Internet Radio - SKY.FM Radio features a wide variety of free streaming radio channels. Find your favorites among the best of each class - be it New Age, 80s, Smooth Jazz, New Age, Top40, Hip Hop, Oldies, 70s, Reggae, Lounge or many others inside.", true );
    Amarok.debug( "ok." );
}

function onConfigure()
{
    Amarok.alert( "This script doesn't require configuration." );
}

function onPopulating( level, callbackData, filter )
{
	filter = filter.toLowerCase().replace("%20","");
	
    if ( level == 1 ) 
    {
        for( att in categories )
        {
	  			if(filter.length > 0)
			{
				var hasItems = false;
				var stationArray = categories[att];
				for ( i = 0; i < stationArray.length; i++ )
				{
					if(stationArray[i].name.toLowerCase().indexOf(filter) != -1)
					{
						hasItems = true;
						break;
					}
				}
				if(!hasItems) continue;
			}
			
            var cover = Amarok.Info.scriptPath() + "/" + images[att];
            Amarok.debug ("att: " + att + ", " + categories[att].name);
      
            item = Amarok.StreamItem;
	    item.level = 1;
	    item.callbackData = att;
	    item.itemName = att;
	    item.playableUrl = "";
	    item.infoHtml = "";
            item.coverUrl = cover;
	    script.insertItem( item );

        }
        script.donePopulating();

    }
    else if ( level == 0 ) 
    {
        Amarok.debug( " Compiling stations..." );
	//add the station streams as leaf nodes

        var stationArray = categories[callbackData];

	for ( i = 0; i < stationArray.length; i++ )
	{
                var cover = Amarok.Info.scriptPath() + "/" + images[callbackData];
		item = Amarok.StreamItem;
		item.level = 0;
		item.callbackData = "";
		item.itemName = stationArray[i].name;
		item.playableUrl = stationArray[i].url;
		item.album = callbackData;
		item.infoHtml = stationArray[i].description;
                item.artist = "Radio Stream";
                item.coverUrl = cover;
		script.insertItem( item );
	}
	script.donePopulating();
    }
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir+"icon.png");
    script.setIcon(iconPixmap);
}

Amarok.configured.connect( onConfigure );

script = new SkyFMRadios();
script.populate.connect( onPopulating );
script.customize.connect( onCustomize );
